Subject: Re: bug#32281: shr.el align support patch

From: Eli Zaretskii <[email-masked]>
Date: Tue, 07 Aug 2018 20:19:00 +0300

> From: Bad Blue Bull <[email-masked]>
> Cc: "[email-masked]" <[email-masked]>,
> 	"[email-masked]" <[email-masked]>
> Date: Tue, 07 Aug 2018 19:54:58 +0300
> 
> I've escaped using of paragraph separator symbol by using narrowing

That's also fine.

> (can't just use constant position as
> fill-region-as-paragraph will change the text before it and it won't correspond the end of paragraph anymore).

We have markers for that.  But if narrowing solves your problem, it's
okay to use that.

> Using a marker symbol to mark line breaks is still necessary, any attempt to avoid it would lead to ridicously
> complicated solution.

Can you explain why?  I still don't think I understand.

> fill-region-as-paragraph disregards fill-collumn when aligns pic, all I can do is not to justify images at all (but I'm
> really puzzled how to do it, I could use other marker just to determine where image starts and ends and skip
> that region, but since you're against such approach... )
> Justification is badly implemented in fill, it's useless for proportional fonts and you can see it's bad for images
> too. TBH would be good to make fill.el just ignore justify in such cases (maybe giving a warning message).

To support proportional fonts, we need:

  . convert all the calculations to work in pixels instead of in
    columns (or, equivalently, in units of the canonical character
    width, in which case you then must use floating-point values)
  . put on some (or all?) SPC characters a :width display property,
    with the suitably calculated width in pixels

The infrastructure for all of that already exists, it's just a matter
of coding.